require 'spec_helper'

module Contender
  describe CopyOnWriteSet do
    it 'handles concurrent operations without errors' do
      set = CopyOnWriteSet.new

      (1..3).map { |i|
        Thread.new do
          100.times do |j|
            n = i * 1000 + j

            set.add n
            set.each { |e| e }

            set.should include(n)

            set.delete n
            set.size
          end
        end
      }.map(&:join)
    end
  end
end
