require 'spec_helper'

module Contender
  describe LinkedQueue do
    it 'works' do
      q = LinkedQueue.new
      x = 10_000

      t1 = Thread.new do
        x.times do
          q.offer Object.new, 5
        end
      end

      t2 = Thread.new do
        x.times do
          q.poll 5
        end
      end

      t1.join
      t2.join
    end
  end
end
